#!/usr/bin/perl
#--NetShopOwner-CGI-version:4.2.5.5--

;#
;# variation_stock.cgi
;# [PC]oG[Vʍ݌Ƀy[W
;# Copyright (c) 2004- Increment P Corp. All rights reserved.
;#
;# 2009/09/30 NSO4Ή
;#

use strict;
use uselib;
use defnsopath_shop;
use NsoVersionPC 1.00;
use Lib::SiteStatus;
use DB::NsoGoodsDB;
use DB::NsoGoodsVariationDB;
use DB::NsoStockDB;

&ReadParse();
my %in    = %main::in;
my %incfn = %main::incfn;
my %inct  = %main::inct;

# CX^X`
my $objConfigSystem = Config::NsoSystem->newShop();
my $objConfigMaster = Config::NsoMaster->new();
my $NsoMisc       = NsoMisc->new();

# RtBO[ṼLbV
my %ConfigSystem = $objConfigSystem->cache_config();
my %ConfigMaster = $objConfigMaster->cache_config();

my $GoodsDB          = NsoGoodsDB->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster});
my $GoodsVariationDB = NsoGoodsVariationDB->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster});
my $StockDB          = NsoStockDB->new({ ConfigSystem=>\%ConfigSystem, ConfigMaster=>\%ConfigMaster});

FUNC:{
	my $func = $in{func} || 'main';
	my %function = (
		main       => \&main,
	);
	
	&check_closing();
	
	if ($function{$func}){
		$function{$func}->();
	}else{
		&main();
	}
}

exit();

;#
;# JXEXԌ
;#
sub check_closing {
	my $SiteStatus = Lib::SiteStatus->new({ ConfigSystem=>\%ConfigSystem });
	$SiteStatus->CheckClosing({ IgnoreFlag=>1 });
}

;#
;# C
;#
sub main {
	my $self = shift;
	my $GoodsID = $in{GoodsID};

	# p[^p̂݁A1ȏłȂƃG[
	unless( $GoodsID =~ m/^\d+$/ ){
		&ShowErrorPage('sȃp[^łB');
	}

	# ev[g{ݒ
	my $system_templ_dir   = $main::nsoDB_path ."/";
	my $system_templ_kind  = "templ";

	# i擾
	my %resultGoods = $GoodsDB->make_GoodsInfoQuery($GoodsID);
	my %resultGoodsHash = (
		RecordList  => $resultGoods{RecordList},
		RecordCount => $resultGoods{RecordCount},
		status_err  => $resultGoods{status_err},
	);

	if ($resultGoodsHash{status_err} ne ""){
		&ShowErrorPage($resultGoodsHash{status_err});
	}

	if ($resultGoodsHash{RecordCount} == 0){
		&ShowErrorPage('i񂪌܂B');
	}

	# i擾
	my %Article = %{$resultGoodsHash{RecordList}[0]};

	# PC\tO̊mF
	if ($Article{DisplayFlag} ne "1"){
		&ShowErrorPage('\ł鏤i񂪂܂B');
	}

	# ݌ɕ\e[u̒g̍쐬
	my $str_body = "";

	# oG[V1ł̊Ǘ
	if($Article{StockType} == "1"){
		# oG[V1̖̂擾
		my %resultArticleVariation1 = $GoodsVariationDB->GetArticleVariationType($GoodsID , 1);
		my %resultArticleVariation1Hash = (
			RecordList  => $resultArticleVariation1{RecordList},
			RecordCount => $resultArticleVariation1{RecordCount},
			status_err  => $resultArticleVariation1{status_err},
		);

		if ($resultArticleVariation1Hash{status_err} ne ""){
			&ShowErrorPage($resultArticleVariation1Hash{status_err});
		}

		if ($resultArticleVariation1Hash{RecordCount} == 0){
			&ShowErrorPage('oG[V1܂B');
		}
		
		# oG[VP̖
		my @ArticleVariation1 = @{$resultArticleVariation1Hash{RecordList}};

		# ݌ɏ̎擾
		my %resultVariationStock = $StockDB->GetVariationStock($GoodsID);
		my %resultVariationStockHash = (
			RecordList  => $resultVariationStock{RecordList},
			RecordCount => $resultVariationStock{RecordCount},
			status_err  => $resultVariationStock{status_err},
		);

		if ($resultVariationStockHash{status_err} ne ""){
			&ShowErrorPage($resultVariationStockHash{status_err});
		}

		if ($resultVariationStockHash{RecordCount} == 0){
			&ShowErrorPage('݌1܂B');
		}

		# ݌ɏ
		my %ArticleStock = %{$resultVariationStockHash{RecordList}};

		# oG[V1pev[gݒ
		my $Data_v1_head = "stock_list_v1_head.htmp";
		my $Data_v1_body = "stock_list_v1_body.htmp";
		my $NsoTempl_v1_head = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$Data_v1_head });
		my $NsoTempl_v1_body = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$Data_v1_body });

		my %Text_v1_head = ();
		$Text_v1_head{"Variation1Header"} = $Article{'VariationTitle1'};
		my %replace_templ_v1_head = (
			Text => \%Text_v1_head ,
		);
		$str_body .= $NsoTempl_v1_head->replace_templ(\%replace_templ_v1_head);

		# ݌ɐe[u̒g쐬
		for(my $i = 0 ; $i < @ArticleVariation1 ; $i++ ){
			my %Text_v1_body = ();
			my $key_string = "" . $ArticleVariation1[$i]{'VariationID'} . "-" . "0";
			$Text_v1_body{"Variation1Name"} = $ArticleVariation1[$i]{'VariationContent'};
			$Text_v1_body{"VariationStock"} = $NsoMisc->CreateStockImagePath($ArticleStock{$key_string});
			my %replace_templ_v1_body = (
				Text => \%Text_v1_body ,
			);
			$str_body .= $NsoTempl_v1_body->replace_templ(\%replace_templ_v1_body,);
		}
	# oG[V2ł̊Ǘ
	} elsif($Article{StockType} == "2"){
		# oG[V1̖̂擾
		my %resultArticleVariation1 = $GoodsVariationDB->GetArticleVariationType($GoodsID , 1);
		my %resultArticleVariation1Hash = (
			RecordList  => $resultArticleVariation1{RecordList},
			RecordCount => $resultArticleVariation1{RecordCount},
			status_err  => $resultArticleVariation1{status_err},
		);

		if ($resultArticleVariation1Hash{status_err} ne ""){
			&ShowErrorPage($resultArticleVariation1Hash{status_err});
		}

		if ($resultArticleVariation1Hash{RecordCount} == 0){
			&ShowErrorPage('oG[V2-1܂B');
		}
		
		# oG[VP̖
		my @ArticleVariation1 = @{$resultArticleVariation1Hash{RecordList}};

		# oG[V2̖̂擾
		my %resultArticleVariation2 = $GoodsVariationDB->GetArticleVariationType($GoodsID , 2);
		my %resultArticleVariation2Hash = (
			RecordList  => $resultArticleVariation2{RecordList},
			RecordCount => $resultArticleVariation2{RecordCount},
			status_err  => $resultArticleVariation2{status_err},
		);

		if ($resultArticleVariation2Hash{status_err} ne ""){
			&ShowErrorPage($resultArticleVariation2Hash{status_err});
		}

		if ($resultArticleVariation2Hash{RecordCount} == 0){
			&ShowErrorPage('oG[V2-2܂B');
		}

		# oG[VQ̖
		my @ArticleVariation2 = @{$resultArticleVariation2Hash{RecordList}};

		# ݌ɏ̎擾
		my %resultVariationStock = $StockDB->GetVariationStock($GoodsID);
		my %resultVariationStockHash = (
			RecordList  => $resultVariationStock{RecordList},
			RecordCount => $resultVariationStock{RecordCount},
			status_err  => $resultVariationStock{status_err},
		);

		if ($resultVariationStockHash{status_err} ne ""){
			&ShowErrorPage($resultVariationStockHash{status_err});
		}

		if ($resultVariationStockHash{RecordCount} == 0){
			&ShowErrorPage('݌2܂B');
		}

		# ݌ɏ
		my %ArticleStock = %{$resultVariationStockHash{RecordList}};

		# oG[V2pev[gݒ
		my $Data_v2_head  = "stock_list_v2_head.htmp";
		my $Data_v2_body1 = "stock_list_v2_body1.htmp";
		my $Data_v2_body2 = "stock_list_v2_body2.htmp";
		my $NsoTempl_v2_head = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$Data_v2_head });
		my $NsoTempl_v2_body1 = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$Data_v2_body1 });
		my $NsoTempl_v2_body2 = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$Data_v2_body2 });

		my %Text_v2_head = ();
		$Text_v2_head{"Variation1Header"} = $Article{'VariationTitle1'};
		$Text_v2_head{"Variation2Header"} = $Article{'VariationTitle2'};
		my %replace_templ_v2_head = (
			Text => \%Text_v2_head ,
		);
		$str_body .= $NsoTempl_v2_head->replace_templ(\%replace_templ_v2_head);

		# ݌ɐe[u̒g쐬
		for(my $i = 0 ; $i < @ArticleVariation1 ; $i++ ){
			my %Text_v2_body1 = ();
			my $key_string = "" . $ArticleVariation1[$i]{'VariationID'} . "-" 
			                    . $ArticleVariation2[0]{'VariationID'};
			$Text_v2_body1{"Variation2Rows"} = "" . @ArticleVariation2;
			$Text_v2_body1{"Variation1Name"} = $ArticleVariation1[$i]{'VariationContent'};
			$Text_v2_body1{"Variation2Name"} = $ArticleVariation2[0]{'VariationContent'};
			$Text_v2_body1{"VariationStock"} = $NsoMisc->CreateStockImagePath($ArticleStock{$key_string});
			my %replace_templ_v2_body1 = (
				Text => \%Text_v2_body1 ,
			);
			$str_body .= $NsoTempl_v2_body1->replace_templ(\%replace_templ_v2_body1);
			
			# 1sڂ̍݌ɐ͏ς݂Ȃ̂ŁǍ
			for(my $j = 1 ; $j < @ArticleVariation2 ; $j++ ){
				my %Text_v2_body2 = ();
				my $key_string = "" . $ArticleVariation1[$i]{'VariationID'} . "-" 
				                    . $ArticleVariation2[$j]{'VariationID'};
				$Text_v2_body2{"Variation2Name"} = $ArticleVariation2[$j]{'VariationContent'};
				$Text_v2_body2{"VariationStock"} = $NsoMisc->CreateStockImagePath($ArticleStock{$key_string});
				my %replace_templ_v2_body2 = (
					Text => \%Text_v2_body2 ,
				);
				$str_body .= $NsoTempl_v2_body2->replace_templ(\%replace_templ_v2_body2);
			}
		}
	} else{
		# oG[Vʍ݌ɊǗł͂ȂB
		&ShowErrorPage('ڍׂ̍݌ɏ񂪂܂B');
	}

	# ev[gݒiwb_[Atb^[j
	my $Data_header = "stock_list_head.htmp";
	my $Data_footer = "stock_list_foot.htmp";
	my $NsoTempl_header = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$Data_header });
	my $NsoTempl_footer = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$Data_footer });

	# ev[guiwb_[Atb^[j
	my %Text_header = ();
	$Text_header{"ArticleName"} = $Article{Name};
	my %replace_templ_header = (
		Text => \%Text_header,
	);

	my %Text_footer = ();
	my %replace_templ_footer = (
		Text => \%Text_footer,
	);

	# ݌Ƀy[Wo
	print $NsoMisc->print_header();
	print $NsoTempl_header->replace_templ(\%replace_templ_header);

	print $str_body;
	
	print $NsoTempl_footer->replace_templ(\%replace_templ_footer);
	exit();
}

;#
;#	G[y[W
;#
;#	@param	: G[bZ[W
;#	@return	: Ȃ
;#
sub ShowErrorPage {
	my $errstr = shift;

	# ev[g{ݒ
	my $system_templ_dir   = $main::nsoDB_path ."/";
	my $system_templ_kind  = "templ";

	# ev[gݒiwb_[Atb^[j
	my $Data_header = "stock_list_head.htmp";
	my $Data_footer = "stock_list_foot.htmp";
	my $NsoTempl_header = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$Data_header });
	my $NsoTempl_footer = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$Data_footer });

	# ev[guiwb_[Atb^[j
	my %Text_header = ();
	my %replace_templ_header = (
		Text => \%Text_header,
	);

	my %Text_footer = ();
	my %replace_templ_footer = (
		Text => \%Text_footer,
	);

	# G[y[Wo
	print $NsoMisc->print_header();
	print $NsoTempl_header->replace_templ(\%replace_templ_header);

	print "<TR><TD>" . '݌ɏ󋵂mFł܂łB' . "</TD></TR>\r\n";
	print "<TR><TD>" . $errstr . "</TD></TR>\r\n";
	
	print $NsoTempl_footer->replace_templ(\%replace_templ_footer);
	exit();
}













